package com.yixin.ms.api;

import com.yixin.ms.api.domain.BaseResidencePermitWrapper;
import com.yixin.ms.api.domain.dto.ResidencePermitTokenDTO;
import com.yixin.ms.api.domain.vo.ResidencePermitTokenVO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

/**
 * @description: 远程居住证相关接口 <br>
 * @date: 2022/9/6 16:49 <br>
 * @author: WXG <br>
 */
@FeignClient(name = "RemoteResidencePermitApi", url = "${residence_permit.host}")
public interface RemoteResidencePermitApi {

    @PostMapping("/token")
    BaseResidencePermitWrapper<ResidencePermitTokenVO> getToken(@RequestBody BaseResidencePermitWrapper<ResidencePermitTokenDTO> tokenDTO);

    @PostMapping("/liveRegisterReport")
    BaseResidencePermitWrapper<Object> liveRegisterReport(@RequestBody BaseResidencePermitWrapper<String> liveRegisterReportDTO);
}
