package com.yixin.ms.api.constant;

import com.baomidou.mybatisplus.annotation.EnumValue;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * @description: 远程流调相关字典项 <br>
 * @date: 2022/9/7 13:01 <br>
 * @author: WXG <br>
 */
@ApiModel("远程流调相关字典项")
public class RemoteResidencePermitDict {
    /**
     * 注销标记
     */
    @Getter
    @ApiModel("注销标记")
    @AllArgsConstructor
    public enum CancelFlag {
        LOGOUT("0", "未注销"),
        UN_LOGOUT("1", "已注销");
        @EnumValue
        @JsonValue
        private final String code;
        private final String description;
    }

    /**
     * 居住处所
     */
    @Getter
    @ApiModel("居住处所")
    @AllArgsConstructor
    public enum Zzcs {
        Hotel("04", "旅店"),
        Hospital("11", "医院"),
        School("24", "学校"),
        TrainingInstitutions("28", "培训机构"),
        InsideTheUnit("29", "单位内部"),
        CentralizedApartments("30", "集中公寓"),
        ResidentHome("31", "居民家中"),
        SelfPurchasing("33", "自购房"),
        RentalHousing("34", "租赁房屋"),
        Construction("41", "工地现场"),
        WaterShip("43", "水上船舶"),
        AidStation("63", "救助站"),
        Other("69", "其它");
        @EnumValue
        @JsonValue
        private final String code;
        private final String description;
    }

    /**
     * 居住事由
     */
    @Getter
    @AllArgsConstructor
    public enum LiveCode {
        MigrantWorkers("01", "务工"),
        Farming("06", "务农"),
        InvestInBusiness("11", "投资经商"),
        Housemaid("37", "保姆"),
        Serving("39", "服务"),
        BusinessTrip("51", "因公出差"),
        BorrowingTraining("53", "借读培训"),
        MedicalTreatment("54", "治病疗养"),
        VisitFriends("55", "探亲访友"),
        Sightseeing("56", "旅游观光"),
        Hire("61", "聘用"),
        MigratingPreschoolChildren("63", "随迁学龄前子女"),
        PrimarySchool("64", "小学"),
        HighSchool("65", "中学"),
        SecondaryAndHigherVocationalSchools("66", "中高等职业学校"),
        CollegesAndUniversities("67", "普通高等学校"),
        TakeRefugeWithRelatives("80", "投靠亲属"),
        Other("99", "其他");
        @EnumValue
        @JsonValue
        private final String code;
        private final String description;
    }


    /**
     * 文化程度
     */
    @Getter
    @AllArgsConstructor
    public enum EduCode {
        Doctor("00", "博士"),
        Postgraduate("10", "研究生"),
        Undergraduate("20", "大学本科"),
        College("30", "大专"),
        TechnicalSecondarySchool("40", "中专中技"),
        TechnicalSchool("50", "技工学校"),
        SeniorMiddleSchool("60", "高中"),
        JuniorHighSchool("70", "初中"),
        PrimarySchool("80", "小学"),
        IlliterateSemiLiterate("90", "文盲半文盲");
        @EnumValue
        @JsonValue
        private final String code;
        private final String description;
    }

    /**
     * 婚姻状况
     */
    @Getter
    @AllArgsConstructor
    public enum MarCode {
        Unmarried("10", "未婚"),
        Married("20", "已婚"),
        Widowed("30", "丧偶"),
        Divorce("40", "离婚"),
        Unknown("90", "不详");
        @EnumValue
        @JsonValue
        private final String code;
        private final String description;
    }

    /**
     * 婚姻状况
     */
    @Getter
    @AllArgsConstructor
    public enum PoliticalCode {
        CPCMember("1", "中共党员"),
        ProbationaryMember("2", "预备党员"),
        CommunistYouthLeague("3", "共青团员"),
        DemocraticParty("4", "民主党派"),
        Other("5", "其他");
        @EnumValue
        @JsonValue
        private final String code;
        private final String description;
    }

    /**
     * 从事职业
     */
    @Getter
    @AllArgsConstructor
    public enum JobCode {
        AgricultureForestryAnimalHusbandryFisheryProduction("10", "农林牧渔生产"),
        ManufacturingAndProcessing("21", "生产制造加工"),
        EngineeringConstruction("22", "工程施工"),
        ShipmentService("31", "运输服务"),
        Decoration("32", "装饰装修"),
        CateringServices("33", "餐饮服务"),
        LeisureAndEntertainmentServices("34", "休闲娱乐服务"),
        Housekeeping("35", "家政服务"),
        SecurityPropertyManagement("36", "保安物管"),
        MaintenanceService("37", "维修服务"),
        PurchaseOfScrapItems("38", "废旧物品收购"),
        OtherBusinessServices("39", "其它商业服务"),
        OtherOccupations("41", "其他职业"),
        Unemployment("51", "失业");
        @EnumValue
        @JsonValue
        private final String code;
        private final String description;
    }

    /**
     * 劳动签订情况
     */
    @Getter
    @AllArgsConstructor
    public enum LaborContractStatus {
        NotSigned("0", "未签"),
        LessThanOneYear("4", "一年以下"),
        MoreThanOneYear("5", "一年及以上");
        @EnumValue
        @JsonValue
        private final String code;
        private final String description;
    }


}
