package com.yixin.ms.api.domain;

import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import com.yixin.ms.boot.restful.ServiceException;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.Map;

/**
 * @description: BaseResidencePermitDTO <br>
 * @date: 2022/9/6 17:09 <br>
 * @author: WXG <br>
 */
@Data
@NoArgsConstructor
public class BaseResidencePermitWrapper<T> {
    private Map<String, String> header;
    private String token;
    private T body;
    private JSONObject other;

    public BaseResidencePermitWrapper(T body) {
        this.body = body;
    }

    public BaseResidencePermitWrapper(String token, T body) {
        this.token = token;
        this.body = body;
    }

    public T valid() {
        if (!"00".equals(header.get("rspCode"))) {
            if("02".equals(header.get("rspCode"))){
                throw new ServiceException(header.get("rspMessage") + ":" + JSONUtil.toJsonStr(body));
            } else {
                throw new ServiceException(header.get("rspMessage"));
            }
        }
        return body;
    }
}
