package com.yixin.ms.api.util;

import cn.hutool.json.JSONUtil;
import org.apache.commons.codec.binary.Base64;

import javax.crypto.*;
import javax.crypto.spec.DESedeKeySpec;
import java.nio.charset.Charset;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.spec.InvalidKeySpecException;

public class DESUtil {
    private static final String KEY_ALGORITHM = "DESede";
    private static final String CIPHER_ALGORITHM = "DESede/ECB/PKCS5Padding";
    private static final String ENCODING = "UTF-8";

    /**
     * @param data body 的 JSON 字符串
     * @param key  腾住提供的 DesSecret 密钥
     * @return
     */
    public static String encrypt(String data, String key) {
        byte[] encrypt = encrypt(data.getBytes(Charset.forName(ENCODING)), key);
        return encrypt == null ? null : Base64.encodeBase64String(encrypt);
    }

    private static byte[] encrypt(byte[] data, String key) {
        try {
            //实例化 Des 密钥
            DESedeKeySpec dks = new DESedeKeySpec(key.getBytes());
            //实例化密钥工厂
            SecretKeyFactory keyFactory =
                    SecretKeyFactory.getInstance(KEY_ALGORITHM);
            //生成密钥
            SecretKey secretKey = keyFactory.generateSecret(dks);
            //实例化
            Cipher cipher = Cipher.getInstance(CIPHER_ALGORITHM);
            //初始化，设置为加密模式
            cipher.init(Cipher.ENCRYPT_MODE, secretKey);
            return cipher.doFinal(data);
        } catch (InvalidKeyException
                | NoSuchAlgorithmException
                | InvalidKeySpecException
                | NoSuchPaddingException
                | IllegalBlockSizeException
                | BadPaddingException e) {
            e.printStackTrace();
        }
        return null;
    }

    public static void main(String[] args) {
        String key = "e231e93a438213bc072ffc14e80bc5b1";
        String data = "{\"name\":\"倪鹏飞\",\"idcard\",\"23022919940714571X\"}";
        // 1BQORnGIK7m9SaERwGJfb0QS5gr2iP2E+qWiGQsL0ARYxUmMtYG/foGqsE1JSbRbpSJXazxL7I8=
        System.out.println("加密后：\r\n"+DESUtil.encrypt(JSONUtil.toJsonStr(data), key));
    }
}
