package com.yixin.ms.controller;


import com.yixin.ms.api.domain.dto.LiveRegisterReportDTO;
import com.yixin.ms.api.domain.vo.LiveRegisterReportVO;
import com.yixin.ms.boot.restful.RestResponse;
import com.yixin.ms.boot.restful.RestResult;
import com.yixin.ms.boot.restful.ServiceException;
import com.yixin.ms.model.enums.TokenEnum;
import com.yixin.ms.service.ResidencePermitService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;


@Slf4j
@RequiredArgsConstructor(onConstructor = @__(@Autowired))
@Api(tags = "居住证相关 API")
@RestController
@RequestMapping("residencePermit")
public class ResidencePermitController {

    private final ResidencePermitService residencePermitService;

    @ApiOperation("居住登记信息报送")
    @PostMapping("/liveRegisterReport")
    public RestResult<LiveRegisterReportVO> getToken(@RequestHeader String token,
                                                     @RequestBody @Validated LiveRegisterReportDTO liveRegisterReportDTO) {
        if (TokenEnum.codeOf(token) == null) {
            throw new ServiceException(700, "token有误，请检查");
        }
        LiveRegisterReportVO liveRegisterReportVO = residencePermitService.liveRegisterReport(liveRegisterReportDTO);
        return RestResponse.ok(liveRegisterReportVO);
    }
}
