package com.yixin.ms.server.enums;

import lombok.Getter;

import java.util.Arrays;

/**
 * 高风险地区接口错误码
 */
@Getter
public enum HighRiskAreaErrorCode {
    SUCCESS("00", "成功"),
    UNKONWN_ERROR("99", "未知异常"),
    NULL_ERROR("03", "请求参数不能为空"),
    INTERFACE_CODE_IS_NULL("03", "接口编码不能为空"),
    APPKEY_IS_NULL("01", "应用KEY不能为空"),
    SIGN_IS_NULL("02", "sign签名不能为空"),
    REQUEST_TIME_IS_NULL("15", "请求时间不能为空"),
    TIMEOUT("07", "请求超时"),
    REQUEST_TIME_FORMAT_ERROR("05", "请求时间格式不正确"),
    INVALID_APP("06", "应用APP无效");
    private final String code;
    private final String description;

    HighRiskAreaErrorCode(String code, String description) {
        this.code = code;
        this.description = description;
    }

    public static HighRiskAreaErrorCode valueFromCode(String code) {
        return Arrays.stream(values()).filter(item -> item.code.equals(code)).findAny().orElse(HighRiskAreaErrorCode.UNKONWN_ERROR);
    }
}
